use clap::Clap;
use log::LevelFilter;

#[derive(Clap)]
pub(crate) struct Args {
    #[clap(long, env("DATABASE_URL"))]
    pub(crate) database_url: String,
    /// What address the vtse server should listen to.
    #[clap(long, env("BIND_ADDRESS"), default_value = "localhost:8080")]
    pub(crate) bind_address: String,
    /// Sets the logging level DB queries should report at.
    #[clap(long, default_value = "off")]
    pub(crate) db_log_level: LevelFilter,
}
